/* ***********************************************************
 * This file was automatically generated on 2020-04-07.      *
 *                                                           *
 * C# Bindings Version 2.1.26                                *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  1.68cm (0.66") OLED display with 64x48 pixels
	/// </summary>
	public class BrickletOLED64x48 : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 264;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "OLED 64x48 Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_WRITE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_NEW_WINDOW = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_CLEAR_DISPLAY = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DISPLAY_CONFIGURATION = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DISPLAY_CONFIGURATION = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_WRITE_LINE = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;



		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletOLED64x48(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 0;



			responseExpected[FUNCTION_WRITE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_NEW_WINDOW] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_CLEAR_DISPLAY] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_SET_DISPLAY_CONFIGURATION] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_DISPLAY_CONFIGURATION] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_WRITE_LINE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Appends 64 byte of data to the window as set by <see cref="Tinkerforge.BrickletOLED64x48.NewWindow"/>.
		///  
		///  Each row has a height of 8 pixels which corresponds to one byte of data.
		///  
		///  Example: if you call <see cref="Tinkerforge.BrickletOLED64x48.NewWindow"/> with column from 0 to 63 and row
		///  from 0 to 5 (the whole display) each call of <see cref="Tinkerforge.BrickletOLED64x48.Write"/> (red arrow) will
		///  write one row.
		///  
		///  .. image:: /Images/Bricklets/bricklet_oled_64x48_display.png
		///     :scale: 100 %
		///     :alt: Display pixel order
		///     :align: center
		///     :target: ../../_images/Bricklets/bricklet_oled_64x48_display.png
		///  
		///  The LSB (D0) of each data byte is at the top and the MSB (D7) is at the
		///  bottom of the row.
		///  
		///  The next call of <see cref="Tinkerforge.BrickletOLED64x48.Write"/> will write the second row and so on. To
		///  fill the whole display you need to call <see cref="Tinkerforge.BrickletOLED64x48.Write"/> 6 times.
		/// </summary>
		public void Write(byte[] data)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(72, FUNCTION_WRITE);
			LEConverter.To((byte[])data, 8, 64, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Sets the window in which you can write with <see cref="Tinkerforge.BrickletOLED64x48.Write"/>. One row
		///  has a height of 8 pixels.
		/// </summary>
		public void NewWindow(byte columnFrom, byte columnTo, byte rowFrom, byte rowTo)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_NEW_WINDOW);
			LEConverter.To((byte)columnFrom, 8, request);
			LEConverter.To((byte)columnTo, 9, request);
			LEConverter.To((byte)rowFrom, 10, request);
			LEConverter.To((byte)rowTo, 11, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Clears the current content of the window as set by <see cref="Tinkerforge.BrickletOLED64x48.NewWindow"/>.
		/// </summary>
		public void ClearDisplay()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_CLEAR_DISPLAY);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Sets the configuration of the display.
		///  
		///  You can set a contrast value from 0 to 255 and you can invert the color
		///  (black/white) of the display.
		/// </summary>
		public void SetDisplayConfiguration(byte contrast, bool invert)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(10, FUNCTION_SET_DISPLAY_CONFIGURATION);
			LEConverter.To((byte)contrast, 8, request);
			LEConverter.To((bool)invert, 9, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the configuration as set by <see cref="Tinkerforge.BrickletOLED64x48.SetDisplayConfiguration"/>.
		/// </summary>
		public void GetDisplayConfiguration(out byte contrast, out bool invert)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DISPLAY_CONFIGURATION);

			byte[] response = SendRequest(request, 10);

			contrast = LEConverter.ByteFrom(8, response);
			invert = LEConverter.BoolFrom(9, response);
		}

		/// <summary>
		///  Writes text to a specific line with a specific position.
		///  The text can have a maximum of 13 characters.
		///  
		///  For example: (1, 4, "Hello") will write *Hello* in the middle of the
		///  second line of the display.
		///  
		///  You can draw to the display with <see cref="Tinkerforge.BrickletOLED64x48.Write"/> and then add text to it
		///  afterwards.
		///  
		///  The display uses a special 5x7 pixel charset. You can view the characters
		///  of the charset in Brick Viewer.
		/// </summary>
		public void WriteLine(byte line, byte position, string text)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(23, FUNCTION_WRITE_LINE);
			LEConverter.To((byte)line, 8, request);
			LEConverter.To((byte)position, 9, request);
			LEConverter.To((string)text, 10, 13, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
		///  connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}
	}
}
